diff -rupN d:\t052/src/game/gamecore.cpp d:\eg/src/game/gamecore.cpp
--- d:\t052/src/game/gamecore.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/gamecore.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -1,6 +1,7 @@
 /* copyright (c) 2007 magnus auvinen, see licence.txt for more info */
 #include <string.h>
 #include "gamecore.hpp"
+#include <game/generated/gs_data.hpp>
 
 const char *TUNING_PARAMS::names[] =
 {
@@ -177,6 +178,8 @@ void CHARACTER_CORE::reset()
 	hooked_player = -1;
 	jumped = 0;
 	triggered_events = 0;
+	hook_power = GREY;
+	suit = false;
 }
 
 void CHARACTER_CORE::tick(bool use_input)
@@ -199,6 +202,24 @@ void CHARACTER_CORE::tick(bool use_input
 	float accel = grounded ? world->tuning.ground_control_accel : world->tuning.air_control_accel;
 	float friction = grounded ? world->tuning.ground_friction : world->tuning.air_friction;
 	
+	// the hook-powerup
+	if (hook_power)
+	{
+		if(gold_decaytick > data->specials.id[SPECIAL_HOOKPWR].duration * SERVER_TICK_SPEED / 1000)
+			hook_power = GREY;
+		else 
+			gold_decaytick++;
+	}
+	
+	// the powersuit
+	if (suit)
+	{
+		if(suit_decaytick > data->specials.id[SPECIAL_POWERSUIT].duration * SERVER_TICK_SPEED / 1000)
+			suit = false;
+		else 
+			suit_decaytick++;
+	}
+	
 	// handle input
 	if(use_input)
 	{
@@ -305,7 +326,7 @@ void CHARACTER_CORE::tick(bool use_input
 		int hit = col_intersect_line(hook_pos, new_pos, &new_pos, 0);
 		if(hit)
 		{
-			if(hit&COLFLAG_NOHOOK)
+			if(hit&COLFLAG_NOHOOK && !(hook_power))
 				going_to_retract = true;
 			else
 				going_to_hit_ground = true;
@@ -333,7 +354,17 @@ void CHARACTER_CORE::tick(bool use_input
 					}
 				}
 			}
-		}
+		
+		if(hooked_player != -1 && world->characters[hooked_player])
+			if (world->characters[hooked_player]->suit)
+			{
+				hook_state = HOOK_RETRACTED;
+				triggered_events |= COREEVENT_HOOK_RETRACT;
+				going_to_retract = true;
+			}
+
+	}
+		
 		
 		if(hook_state == HOOK_FLYING)
 		{
@@ -397,8 +428,17 @@ void CHARACTER_CORE::tick(bool use_input
 				
 		}
 
-		// release hook (max hook time is 1.25
+		// release hook (max hook time is 1.25)
 		hook_tick++;
+		
+		if(hooked_player != -1 && world->characters[hooked_player])
+			if(world->characters[hooked_player]->suit)
+			{
+				hooked_player = -1;
+				hook_state = HOOK_RETRACTED;
+				hook_pos = pos;
+			}
+			
 		if(hooked_player != -1 && (hook_tick > SERVER_TICK_SPEED+SERVER_TICK_SPEED/5 || !world->characters[hooked_player]))
 		{
 			hooked_player = -1;
@@ -485,6 +525,7 @@ void CHARACTER_CORE::write(NETOBJ_CHARAC
 	obj_core->jumped = jumped;
 	obj_core->direction = direction;
 	obj_core->angle = angle;
+	obj_core->specialstate = hook_power + (int)suit;
 }
 
 void CHARACTER_CORE::read(const NETOBJ_CHARACTER_CORE *obj_core)
@@ -503,6 +544,16 @@ void CHARACTER_CORE::read(const NETOBJ_C
 	jumped = obj_core->jumped;
 	direction = obj_core->direction;
 	angle = obj_core->angle;
+	if(obj_core->specialstate == 3)
+	{
+		hook_power = GOLD;
+		suit = true;
+	}
+	else if(obj_core->specialstate == 2)
+		hook_power = GOLD;
+	else if(obj_core->specialstate == 1)
+		suit = true;
+	else return;
 }
 
 void CHARACTER_CORE::quantize()
diff -rupN d:\t052/src/game/gamecore.hpp d:\eg/src/game/gamecore.hpp
--- d:\t052/src/game/gamecore.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/gamecore.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -137,6 +137,9 @@ enum
 	HOOK_FLYING,
 	HOOK_GRABBED,
 	
+	GREY=0,
+	GOLD=2,
+	
 	COREEVENT_GROUND_JUMP=0x01,
 	COREEVENT_AIR_JUMP=0x02,
 	COREEVENT_HOOK_LAUNCH=0x04,
@@ -171,6 +174,11 @@ public:
 	int hook_tick;
 	int hook_state;
 	int hooked_player;
+	int hook_power;
+	int gold_decaytick;
+	
+	bool suit;
+	int suit_decaytick;
 	
 	int jumped;
 	
diff -rupN d:\t052/src/game/mapitems.hpp d:\eg/src/game/mapitems.hpp
--- d:\t052/src/game/mapitems.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/mapitems.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -39,12 +39,32 @@ enum
 	ENTITY_WEAPON_GRENADE,
 	ENTITY_POWERUP_NINJA,
 	ENTITY_WEAPON_RIFLE,
+	ENTITY_POWERUP_HOOK,
+	ENTITY_WEAPON_SHAFT,
+	ENTITY_WEAPON_SPINGUN,
+	ENTITY_ARMOR_5,
+	ENTITY_ARMOR_10,
+	ENTITY_HEALTH_10,
+	ENTITY_POWERUP_SUIT,
+	ENTITY_WEAPON_BIORIFLE,
 	NUM_ENTITIES,
 	
 	TILE_AIR=0,
 	TILE_SOLID,
 	TILE_DEATH,
 	TILE_NOHOOK,
+	TILE_JUMPPAD_WEAK=23,
+	TILE_JUMPPAD_AVERAGE,
+	TILE_JUMPPAD_STRONG,
+	TILE_BOOSTDOWN_WEAK,
+	TILE_BOOSTDOWN_AVERAGE,
+	TILE_BOOSTDOWN_STRONG,
+	TILE_BOOSTLEFT_WEAK,
+	TILE_BOOSTLEFT_AVERAGE,
+	TILE_BOOSTLEFT_STRONG,
+	TILE_BOOSTRIGHT_WEAK,
+	TILE_BOOSTRIGHT_AVERAGE,
+	TILE_BOOSTRIGHT_STRONG,
 	
 	TILEFLAG_VFLIP=1,
 	TILEFLAG_HFLIP=2,
diff -rupN d:\t052/src/game/server/entities/character.cpp d:\eg/src/game/server/entities/character.cpp
--- d:\t052/src/game/server/entities/character.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/character.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -3,10 +3,14 @@
 #include <engine/e_config.h>
 #include <game/server/gamecontext.hpp>
 #include <game/mapitems.hpp>
+#include <string.h>
 
 #include "character.hpp"
 #include "laser.hpp"
+#include "sparkle.hpp"
 #include "projectile.hpp"
+#include "vortex.hpp"
+#include "droppedweapon.hpp"
 
 struct INPUT_COUNT
 {
@@ -261,7 +265,8 @@ void CHARACTER::fire_weapon()
 	vec2 direction = normalize(vec2(latest_input.target_x, latest_input.target_y));
 	
 	bool fullauto = false;
-	if(active_weapon == WEAPON_GRENADE || active_weapon == WEAPON_SHOTGUN || active_weapon == WEAPON_RIFLE)
+	if(active_weapon == WEAPON_GRENADE || active_weapon == WEAPON_SHOTGUN || active_weapon == WEAPON_RIFLE 
+		|| active_weapon == WEAPON_SHAFT || active_weapon == WEAPON_BIORIFLE)
 		fullauto = true;
 
 
@@ -349,13 +354,16 @@ void CHARACTER::fire_weapon()
 		case WEAPON_SHOTGUN:
 		{
 			int shotspread = 2;
+			
+			if(game.controller->is_extended())
+				shotspread = 3;
 
 			msg_pack_start(NETMSGTYPE_SV_EXTRAPROJECTILE, 0);
 			msg_pack_int(shotspread*2+1);
 			
 			for(int i = -shotspread; i <= shotspread; i++)
 			{
-				float spreading[] = {-0.185f, -0.070f, 0, 0.070f, 0.185f};
+				float spreading[] = {-0.400f, -0.185f, -0.070f, 0, 0.070f, 0.185f, 0.400f, 0.450f};
 				float a = get_angle(direction);
 				a += spreading[i+2];
 				float v = 1-(abs(i)/(float)shotspread);
@@ -410,6 +418,32 @@ void CHARACTER::fire_weapon()
 			game.create_sound(pos, SOUND_RIFLE_FIRE);
 		} break;
 		
+		case WEAPON_SHAFT:
+		{
+			// sparkle isn't recreated, so there can be a constant animation
+			if(activesparkle)
+				activesparkle->cooled = true;
+			else
+				activesparkle = new SPARKLE(pos, direction, player->client_id);
+		} break;
+		
+		case WEAPON_SPINGUN:
+		{
+			new VORTEX(pos, direction, player->client_id);
+		} break;
+		
+		case WEAPON_BIORIFLE:
+		{
+			PROJECTILE *proj = new PROJECTILE(WEAPON_BIORIFLE,
+			player->client_id,
+			projectile_startpos,
+			direction,
+			(int)(server_tickspeed()*tuning.biorifle_lifetime),
+			1, PROJECTILE::PROJECTILE_FLAGS_EXPLODE, 0, SOUND_BIO_IMPACT, WEAPON_BIORIFLE);
+			
+			game.create_sound(pos, SOUND_BIORIFLE_FIRE);
+		} break;
+		
 		case WEAPON_NINJA:
 		{
 			attack_tick = server_tick();
@@ -426,7 +460,21 @@ void CHARACTER::fire_weapon()
 		} break;
 		
 	}
-
+	
+	//last entry is overall
+	if(active_weapon == WEAPON_SHOTGUN)
+	{
+		player->weapons[NUM_WEAPONS].shots += 5;
+		player->weapons[WEAPON_SHOTGUN].shots += 5;
+	}
+	else
+	{
+		player->weapons[NUM_WEAPONS].shots++;
+		player->weapons[active_weapon].shots++;
+	}
+	
+	update_accuracy(active_weapon);
+	
 	if(weapons[active_weapon].ammo > 0) // -1 == unlimited
 		weapons[active_weapon].ammo--;
 	attack_tick = server_tick();
@@ -437,7 +485,32 @@ void CHARACTER::fire_weapon()
 int CHARACTER::handle_weapons()
 {
 	vec2 direction = normalize(vec2(latest_input.target_x, latest_input.target_y));
-
+	
+	if (input.drop && !previnput.drop && active_weapon > WEAPON_GUN && active_weapon != WEAPON_NINJA && weapons[active_weapon].ammo)
+	{
+		new DROPPEDWEAPON(pos, direction, active_weapon, weapons[active_weapon].ammo);
+		weapons[active_weapon].ammo = 0;
+		weapons[active_weapon].got = false;
+		
+		if(!weapons[last_weapon].got)
+		{
+			for(int i = 0; i < NUM_WEAPONS; i++)
+			{
+				if(weapons[i].got)
+					last_weapon = i;
+			}
+		}
+		active_weapon = last_weapon;
+	}
+		
+	if (activesparkle)
+		if (latest_input.fire&1 && active_weapon == WEAPON_SHAFT && weapons[WEAPON_SHAFT].ammo)
+			activesparkle->adjust_position(core.pos, direction);
+		else
+		{
+			game.world.destroy_entity(activesparkle);
+			activesparkle = 0x0;
+		}
 	/*
 	if(config.dbg_stress)
 	{
@@ -544,6 +617,89 @@ void CHARACTER::tick()
 	core.input = input;
 	core.tick(true);
 	
+	//overfilldecay
+	if(decaytimer)
+	{
+		decaytimer--;
+		
+		if(!decaytimer)
+		{
+			armor = armor - (int)(armor/11);
+			health = health - (int)(health/11);
+	
+			if(health > 10 || armor > 10)
+				decaytimer = (int)(server_tickspeed()*tuning.overfill_decayrate);
+		}
+	}
+		
+	
+	//check if player is hooked by someone with hook-powerup (hook_power)
+	for (int i = 0; i < MAX_CLIENTS; i++)
+	{
+		if(!core.world->characters[i]) continue;
+		if(core.world->characters[i]->hooked_player == player->client_id && core.world->characters[i]->hook_tick % 17 == 0 && core.world->characters[i]->hook_power)
+		{
+			vec2 dir = normalize(core.pos - core.world->characters[i]->pos);
+			take_damage(dir * 0.001f, tuning.hook_damage, i, WEAPON_HOOK);
+		}
+	}
+	
+	int current_tile_index = col_get_index(core.pos.x, core.pos.y);
+	
+	if(current_tile_index > 22 && current_tile_index < 35 && game.controller->is_extended())
+	{
+		// weak, average, strong = 1 , 2,  3.
+		int boostmultiplier = ((current_tile_index-2) % 3) + 1;
+		
+		// up, down, left, right = 8, 9, 10, 11.
+		int boostdir = (int)round((float)current_tile_index / 3);
+		
+		//up
+		if(boostdir == 8)
+		{
+			core.vel.y = -40 * boostmultiplier;
+		}
+		
+		//down
+		if(boostdir == 9)
+		{
+			core.vel.y = 40 * boostmultiplier;
+		}
+		
+		//left
+		if(boostdir == 10)
+		{
+			core.vel.x = -40 * boostmultiplier;
+		}
+		
+		//right
+		if(boostdir == 11)
+		{
+			core.vel.x = 40 * boostmultiplier;
+		}
+		
+	}
+	
+	
+	int z = col_is_teleport(pos.x, pos.y);
+	if(config.sv_teleport && z && game.controller->is_extended())
+	{
+		core.hooked_player = -1;
+		core.hook_state = HOOK_RETRACTED;
+		core.triggered_events |= COREEVENT_HOOK_RETRACT;
+		core.hook_state = HOOK_RETRACTED;
+		core.pos = teleport(z);
+		core.hook_pos = core.pos;
+/* 		if(config.sv_strip)
+		{
+			active_weapon = WEAPON_HAMMER;
+			last_weapon = WEAPON_HAMMER;
+			weapons[0].got = true;
+			for(int i = 1; i < 5; i++)
+				weapons[i].got = false;
+		} */
+	}
+	
 	float phys_size = 28.0f;
 	// handle death-tiles
 	if(col_get((int)(pos.x+phys_size/2), (int)(pos.y-phys_size/2))&COLFLAG_DEATH ||
@@ -606,7 +762,8 @@ void CHARACTER::tick_defered()
 		if(events&COREEVENT_GROUND_JUMP) game.create_sound(pos, SOUND_PLAYER_JUMP, mask);
 		
 		//if(events&COREEVENT_HOOK_LAUNCH) snd_play_random(CHN_WORLD, SOUND_HOOK_LOOP, 1.0f, pos);
-		if(events&COREEVENT_HOOK_ATTACH_PLAYER) game.create_sound(pos, SOUND_HOOK_ATTACH_PLAYER, cmask_all());
+		if(events&COREEVENT_HOOK_ATTACH_PLAYER && !core.hook_power) game.create_sound(pos, SOUND_HOOK_ATTACH_PLAYER, cmask_all());
+		if(events&COREEVENT_HOOK_ATTACH_PLAYER && core.hook_power) game.create_sound(pos, SOUND_GOLD_ATTACH_PLAYER, cmask_all());
 		if(events&COREEVENT_HOOK_ATTACH_GROUND) game.create_sound(pos, SOUND_HOOK_ATTACH_GROUND, mask);
 		if(events&COREEVENT_HOOK_HIT_NOHOOK) game.create_sound(pos, SOUND_HOOK_NOATTACH, mask);
 		//if(events&COREEVENT_HOOK_RETRACT) snd_play_random(CHN_WORLD, SOUND_PLAYER_JUMP, 1.0f, pos);
@@ -639,17 +796,42 @@ void CHARACTER::tick_defered()
 
 bool CHARACTER::increase_health(int amount)
 {
-	if(health >= 10)
+	//no filling with maxhealth
+	if(health >= 20)
+		return false;
+	
+	//only mega overfills
+	if((health >= 10) && (amount < 10))
 		return false;
-	health = clamp(health+amount, 0, 10);
+		
+	//when it's no overfilling, health maxes out at 10
+	
+	if((health < 10) && (amount < 10))
+	{
+		health = clamp(health+amount, 0, 10);
+		return true;
+	}
+	
+	//must be overfilling by now
+	//set decaytimer if not set	
+	if(!decaytimer && (health+amount) > 10)
+		decaytimer = (int)(server_tickspeed()*tuning.overfill_decayrate);
+	
+	//overfilling maxes out at 20
+	health = clamp(health+amount, 0, 20);
 	return true;
 }
 
 bool CHARACTER::increase_armor(int amount)
 {
-	if(armor >= 10)
+	if(armor >= 10 + (10*(int)game.controller->is_extended()))
 		return false;
-	armor = clamp(armor+amount, 0, 10);
+		
+	//armor always overfills
+	if((armor + amount) > 10 && !decaytimer && game.controller->is_extended())
+		decaytimer = (int)(server_tickspeed()*tuning.overfill_decayrate);
+		
+	armor = clamp(armor+amount, 0, 10 + (10*(int)game.controller->is_extended()));
 	return true;
 }
 
@@ -682,11 +864,18 @@ void CHARACTER::die(int killer, int weap
 	dead = true;
 	*/
 	
+	if(active_weapon > WEAPON_GUN && active_weapon != WEAPON_NINJA && weapons[active_weapon].ammo)
+		new DROPPEDWEAPON(pos, vec2(0, 0), active_weapon, weapons[active_weapon].ammo);
+	
 	// this is for auto respawn after 3 secs
 	player->die_tick = server_tick();
 	
 	alive = false;
 	game.world.remove_entity(this);
+	
+	if(activesparkle)
+		game.world.destroy_entity(activesparkle);
+	
 	game.world.core.characters[player->client_id] = 0;
 	game.create_death(pos, player->client_id);
 	
@@ -701,9 +890,16 @@ bool CHARACTER::take_damage(vec2 force, 
 	if(game.controller->is_friendly_fire(player->client_id, from) && !config.sv_teamdamage)
 		return false;
 
-	// player only inflicts half damage on self
+	// player only inflicts half [changed to: 3/4] damage on self
 	if(from == player->client_id)
-		dmg = max(1, dmg/2);
+		dmg = (int)max(0, ((float)dmg/4 *3));
+		
+	if(weapon != WEAPON_HOOK)
+	{
+		game.players[from]->weapons[NUM_WEAPONS].hits++;
+		game.players[from]->weapons[weapon].hits++;
+		game.players[from]->get_character()->update_accuracy(weapon);
+	}
 
 	damage_taken++;
 
@@ -781,6 +977,12 @@ bool CHARACTER::take_damage(vec2 force, 
 	return true;
 }
 
+void CHARACTER::update_accuracy(int weapon)
+{
+	player->weapons[weapon].accuracy = ((float)player->weapons[weapon].hits / (float)player->weapons[weapon].shots) * 100;
+	player->weapons[NUM_WEAPONS].accuracy = ((float)player->weapons[NUM_WEAPONS].hits / (float)player->weapons[NUM_WEAPONS].shots) *100;
+}
+
 void CHARACTER::snap(int snapping_client)
 {
 	if(networkclipped(snapping_client))
diff -rupN d:\t052/src/game/server/entities/character.hpp d:\eg/src/game/server/entities/character.hpp
--- d:\t052/src/game/server/entities/character.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/character.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -39,10 +39,12 @@ public:
 	int active_weapon;
 	int last_weapon;
 	int queued_weapon;
+	class SPARKLE *activesparkle;
 	
 	int reload_timer;
 	int attack_tick;
 	
+	
 	int damage_taken;
 
 	int emote_type;
@@ -70,6 +72,7 @@ public:
 
 	int health;
 	int armor;
+	int decaytimer;
 
 	// ninja
 	struct
@@ -115,7 +118,8 @@ public:
 	void die(int killer, int weapon);
 
 	bool take_damage(vec2 force, int dmg, int from, int weapon);	
-
+	
+	void update_accuracy(int weapon);
 	
 	bool spawn(PLAYER *player, vec2 pos, int team);
 	//bool init_tryspawn(int team);
diff -rupN d:\t052/src/game/server/entities/droppedweapon.cpp d:\eg/src/game/server/entities/droppedweapon.cpp
--- d:\t052/src/game/server/entities/droppedweapon.cpp	1970-01-01 01:00:00.000000000 +0100
+++ d:\eg/src/game/server/entities/droppedweapon.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -0,0 +1,88 @@
+#include <engine/e_server_interface.h>
+#include <game/generated/g_protocol.hpp>
+#include <game/server/gamecontext.hpp>
+#include "droppedweapon.hpp"
+
+
+DROPPEDWEAPON::DROPPEDWEAPON(vec2 pos, vec2 direction, int subtype, int ammunition)
+: ENTITY(NETOBJTYPE_DROPPED_WEAPON)
+{
+	this->pos = vec2(pos.x, pos.y-30);
+	this->direction = direction;
+	this->subtype = subtype;
+	this->ammunition = ammunition;
+	curvature = tuning.droppedweapon_curvature;
+	speed = tuning.droppedweapon_speed;
+	droptick = server_tick();
+	game.world.insert_entity(this);
+}
+
+vec2 DROPPEDWEAPON::get_pos(float time)
+{
+	return calc_pos(pos, direction, curvature, speed, time);
+}
+
+void DROPPEDWEAPON::tick()
+{
+	if(!still)
+	{
+		float pt = (server_tick()-droptick-1)/(float)server_tickspeed();
+		float ct = (server_tick()-droptick)/(float)server_tickspeed();
+		vec2 prevpos = get_pos(pt);
+		vec2 curpos = get_pos(ct);
+
+		int collide = col_intersect_line(prevpos, curpos, &curpos, 0);
+		
+		if(collide)
+		{
+			curvature = 0.0f;
+			pos = prevpos;
+			speed = 0.0f;
+			still = true;
+			direction = vec2(0, 0);
+		}
+	}
+	
+	if(server_tick() > droptick + server_tickspeed() * tuning.droppedweapon_decayrate)
+		game.world.destroy_entity(this);
+	else if(subtype < NUM_WEAPONS && server_tick() > droptick + server_tickspeed())
+		{
+			CHARACTER *chr = game.world.closest_character(pos, 20.0f, 0);
+
+			if(chr && chr->alive && (chr->weapons[subtype].ammo < data->weapons.id[subtype].maxammo || !chr->weapons[subtype].got))
+				{
+					chr->weapons[subtype].got = true;
+					chr->weapons[subtype].ammo = min((chr->weapons[subtype].ammo + ammunition), data->weapons.id[subtype].maxammo);
+						
+						//TODO: data compiler should take care of stuff like this
+					if(subtype == WEAPON_GRENADE)
+						game.create_sound(pos, SOUND_PICKUP_GRENADE);
+					else if(subtype == WEAPON_SHOTGUN)
+						game.create_sound(pos, SOUND_PICKUP_SHOTGUN);
+					else if(subtype == WEAPON_RIFLE)
+						game.create_sound(pos, SOUND_PICKUP_SHOTGUN);
+
+					if(chr->player)
+						game.send_weapon_pickup(chr->player->client_id, subtype);
+						
+					game.world.destroy_entity(this);
+				}
+			
+		}
+	else return;
+}
+
+void DROPPEDWEAPON::snap(int snapping_client)
+{
+	NETOBJ_DROPPED_WEAPON *dw = (NETOBJ_DROPPED_WEAPON *)snap_new_item(NETOBJTYPE_DROPPED_WEAPON, id, sizeof(NETOBJ_DROPPED_WEAPON));
+	dw->x = (int)pos.x;
+	dw->y = (int)pos.y;
+	dw->vx = (int)(direction.x*100.0f);
+	dw->vy = (int)(direction.y*100.0f);
+	dw->subtype = subtype;
+	
+	if(still)
+		dw->start_tick = server_tick();
+	else
+		dw->start_tick = droptick;
+}
\ No newline at end of file
diff -rupN d:\t052/src/game/server/entities/droppedweapon.hpp d:\eg/src/game/server/entities/droppedweapon.hpp
--- d:\t052/src/game/server/entities/droppedweapon.hpp	1970-01-01 01:00:00.000000000 +0100
+++ d:\eg/src/game/server/entities/droppedweapon.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -0,0 +1,27 @@
+
+
+#ifndef GAME_SERVER_ENTITY_DROPPEDWEAPON_H
+#define GAME_SERVER_ENTITY_DROPPEDWEAPON_H
+
+#include <game/server/entity.hpp>
+
+class DROPPEDWEAPON : public ENTITY
+{
+public:
+	static const int phys_size = 14;
+	int subtype;
+	int ammunition;
+	int droptick;
+	float speed;
+	float curvature;
+	bool still;
+	vec2 direction;
+	
+	DROPPEDWEAPON(vec2 pos, vec2 direction, int subtype, int ammunition);
+	
+	vec2 get_pos(float time);
+	virtual void tick();
+	virtual void snap(int snapping_client);
+};
+
+#endif
\ No newline at end of file
diff -rupN d:\t052/src/game/server/entities/laser.cpp d:\eg/src/game/server/entities/laser.cpp
--- d:\t052/src/game/server/entities/laser.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/laser.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -16,6 +16,7 @@ LASER::LASER(vec2 pos, vec2 direction, f
 	dir = direction;
 	bounces = 0;
 	do_bounce();
+	type = WEAPON_RIFLE;
 	
 	game.world.insert_entity(this);
 }
@@ -31,8 +32,9 @@ bool LASER::hit_character(vec2 from, vec
 
 	this->from = from;
 	pos = at;
-	energy = -1;		
-	hit->take_damage(vec2(0,0), tuning.laser_damage, owner, WEAPON_RIFLE);
+	energy = -1;
+	int dmg = (int)(tuning.laser_damage + (tuning.laser_damage * 0.6f * (int)game.controller->is_extended()));
+	hit->take_damage(vec2(0,0), dmg, owner, WEAPON_RIFLE);
 	return true;
 }
 
@@ -111,5 +113,6 @@ void LASER::snap(int snapping_client)
 	obj->y = (int)pos.y;
 	obj->from_x = (int)from.x;
 	obj->from_y = (int)from.y;
+	obj->type = type;
 	obj->start_tick = eval_tick;
 }
diff -rupN d:\t052/src/game/server/entities/laser.hpp d:\eg/src/game/server/entities/laser.hpp
--- d:\t052/src/game/server/entities/laser.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/laser.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -14,15 +14,16 @@ class LASER : public ENTITY
 	float energy;
 	int bounces;
 	int eval_tick;
-	int owner;
-	
-	bool hit_character(vec2 from, vec2 to);
+
 	void do_bounce();
 	
 public:
+	int owner;
+	int type;
 	
 	LASER(vec2 pos, vec2 direction, float start_energy, int owner);
 	
+	virtual bool hit_character(vec2 from, vec2 to);
 	virtual void reset();
 	virtual void tick();
 	virtual void snap(int snapping_client);
diff -rupN d:\t052/src/game/server/entities/pickup.cpp d:\eg/src/game/server/entities/pickup.cpp
--- d:\t052/src/game/server/entities/pickup.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/pickup.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -21,7 +21,9 @@ PICKUP::PICKUP(int _type, int _subtype)
 
 void PICKUP::reset()
 {
-	if (data->pickups[type].spawndelay > 0)
+	if (type == POWERUP_SPECIAL && data->specials.id[subtype].spawndelay > 0 && game.controller->is_extended())
+		spawntick = server_tick() + server_tickspeed() * data->specials.id[subtype].spawndelay;
+	else if (data->pickups[type].spawndelay > 0)
 		spawntick = server_tick() + server_tickspeed() * data->pickups[type].spawndelay;
 	else
 		spawntick = -1;
@@ -53,35 +55,40 @@ void PICKUP::tick()
 		switch (type)
 		{
 		case POWERUP_HEALTH:
-			if(chr->increase_health(1))
+			if(!subtype)
 			{
-				game.create_sound(pos, SOUND_PICKUP_HEALTH);
-				respawntime = data->pickups[type].respawntime;
+				if(chr->increase_health(1))
+				{
+					game.create_sound(pos, SOUND_PICKUP_HEALTH);
+					respawntime = data->pickups[type].respawntime;
+				}
 			}
 			break;
+			
 		case POWERUP_ARMOR:
-			if(chr->increase_armor(1))
-			{
-				game.create_sound(pos, SOUND_PICKUP_ARMOR);
-				respawntime = data->pickups[type].respawntime;
-			}
-			break;
+			if(!subtype)
+				{
+					if(chr->increase_armor(1))
+					{
+						game.create_sound(pos, SOUND_PICKUP_ARMOR);
+						respawntime = data->pickups[type].respawntime;
+					}
+				}
+				break;
 
-		case POWERUP_WEAPON:
-			if(subtype >= 0 && subtype < NUM_WEAPONS)
+		case POWERUP_WEAPON: // 
+			if(subtype >= 0 && subtype < NUM_WEAPONS) 
 			{
 				if(chr->weapons[subtype].ammo < data->weapons.id[subtype].maxammo || !chr->weapons[subtype].got)
 				{
 					chr->weapons[subtype].got = true;
-					chr->weapons[subtype].ammo = min(data->weapons.id[subtype].maxammo, chr->weapons[subtype].ammo + 10);
+					chr->weapons[subtype].ammo = min(data->weapons.id[subtype].maxammo, chr->weapons[subtype].ammo + 100);
 					respawntime = data->pickups[type].respawntime;
 
 					// TODO: data compiler should take care of stuff like this
-					if(subtype == WEAPON_GRENADE)
+					if(subtype == WEAPON_GRENADE || subtype == WEAPON_SPINGUN || subtype == WEAPON_SHAFT)
 						game.create_sound(pos, SOUND_PICKUP_GRENADE);
-					else if(subtype == WEAPON_SHOTGUN)
-						game.create_sound(pos, SOUND_PICKUP_SHOTGUN);
-					else if(subtype == WEAPON_RIFLE)
+					else if(subtype == WEAPON_SHOTGUN || subtype == WEAPON_RIFLE || WEAPON_BIORIFLE)
 						game.create_sound(pos, SOUND_PICKUP_SHOTGUN);
 
 					if(chr->player)
@@ -89,33 +96,73 @@ void PICKUP::tick()
 				}
 			}
 			break;
-		case POWERUP_NINJA:
+		case POWERUP_SPECIAL:
 			{
-				// activate ninja on target player
-				chr->ninja.activationtick = server_tick();
-				chr->weapons[WEAPON_NINJA].got = true;
-				chr->weapons[WEAPON_NINJA].ammo = -1;
-				chr->last_weapon = chr->active_weapon;
-				chr->active_weapon = WEAPON_NINJA;
-				respawntime = data->pickups[type].respawntime;
-				game.create_sound(pos, SOUND_PICKUP_NINJA);
-
-				// loop through all players, setting their emotes
-				ENTITY *ents[64];
-				int num = game.world.find_entities(vec2(0, 0), 1000000, ents, 64, NETOBJTYPE_CHARACTER);
-				for (int i = 0; i < num; i++)
+				if(subtype == SPECIAL_NINJAPWR)
 				{
-					CHARACTER *c = (CHARACTER *)ents[i];
-					if (c != chr)
+					// activate ninja on target player
+					chr->ninja.activationtick = server_tick();
+					chr->weapons[WEAPON_NINJA].got = true;
+					chr->weapons[WEAPON_NINJA].ammo = -1;
+					chr->last_weapon = chr->active_weapon;
+					chr->active_weapon = WEAPON_NINJA;
+					respawntime = data->pickups[type].respawntime;
+					game.create_sound(pos, SOUND_PICKUP_NINJA);
+
+					// loop through all players, setting their emotes
+					ENTITY *ents[64];
+					int num = game.world.find_entities(vec2(0, 0), 1000000, ents, 64, NETOBJTYPE_CHARACTER);
+					for (int i = 0; i < num; i++)
 					{
-						c->emote_type = EMOTE_SURPRISE;
-						c->emote_stop = server_tick() + server_tickspeed();
+						CHARACTER *c = (CHARACTER *)ents[i];
+						if (c != chr)
+						{
+							c->emote_type = EMOTE_SURPRISE;
+							c->emote_stop = server_tick() + server_tickspeed();
+						}
 					}
-				}
 
-				chr->emote_type = EMOTE_ANGRY;
-				chr->emote_stop = server_tick() + 1200 * server_tickspeed() / 1000;
-				
+					chr->emote_type = EMOTE_ANGRY;
+					chr->emote_stop = server_tick() + 1200 * server_tickspeed() / 1000;
+				}
+				else if(subtype == SPECIAL_HOOKPWR)
+				{
+					chr->core.gold_decaytick = 0;
+					chr->core.hook_power = GOLD;
+					respawntime = data->pickups[type].respawntime;
+					game.create_sound_global(SOUND_PICKUP_GOLD);
+				}
+				else if(subtype == SPECIAL_POWERSUIT)
+				{
+					chr->core.suit_decaytick = 0;
+					chr->core.suit = true;
+					respawntime = data->specials.id[subtype].respawntime;
+					game.create_sound_global(SOUND_PICKUP_SUIT);
+				}
+				else if(subtype == SPECIAL_MEGAHEALTH)
+				{
+					if(chr->increase_health(10))
+					{
+						game.create_sound(pos, SOUND_PICKUP_HEALTH);
+						respawntime = data->specials.id[subtype].respawntime;
+					}
+				}
+				else if(subtype == SPECIAL_YELLOWARMOR)
+				{
+					if(chr->increase_armor(5))
+					{
+						game.create_sound(pos, SOUND_PICKUP_ARMOR);
+						respawntime = data->specials.id[subtype].respawntime;
+					}
+				}
+				else if(subtype == SPECIAL_REDARMOR)
+				{
+					if(chr->increase_armor(10))
+					{
+						game.create_sound(pos, SOUND_PICKUP_ARMOR);
+						respawntime = data->specials.id[subtype].respawntime;
+					}
+				}
 				break;
 			}
 		default:
diff -rupN d:\t052/src/game/server/entities/projectile.cpp d:\eg/src/game/server/entities/projectile.cpp
--- d:\t052/src/game/server/entities/projectile.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/server/entities/projectile.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -1,7 +1,9 @@
 #include <engine/e_server_interface.h>
 #include <game/generated/g_protocol.hpp>
+#include <engine/e_config.h>
 #include <game/server/gamecontext.hpp>
 #include "projectile.hpp"
+#include <game/generated/g_protocol.hpp>
 
 
 //////////////////////////////////////////////////
@@ -23,18 +25,9 @@ PROJECTILE::PROJECTILE(int type, int own
 	this->weapon = weapon;
 	this->bounce = 0;
 	this->start_tick = server_tick();
+	sticked = false;
 	game.world.insert_entity(this);
-}
-
-void PROJECTILE::reset()
-{
-	game.world.destroy_entity(this);
-}
-
-vec2 PROJECTILE::get_pos(float time)
-{
-	float curvature = 0;
-	float speed = 0;
+	
 	if(type == WEAPON_GRENADE)
 	{
 		curvature = tuning.grenade_curvature;
@@ -50,7 +43,20 @@ vec2 PROJECTILE::get_pos(float time)
 		curvature = tuning.gun_curvature;
 		speed = tuning.gun_speed;
 	}
-	
+	else if(type == WEAPON_BIORIFLE)
+	{
+		curvature = tuning.biorifle_curvature;
+		speed = tuning.biorifle_speed;
+	}
+}
+
+void PROJECTILE::reset()
+{
+	game.world.destroy_entity(this);
+}
+
+vec2 PROJECTILE::get_pos(float time)
+{
 	return calc_pos(pos, direction, curvature, speed, time);
 }
 
@@ -64,12 +70,72 @@ void PROJECTILE::tick()
 	vec2 curpos = get_pos(ct);
 
 	lifespan--;
-	
+
 	int collide = col_intersect_line(prevpos, curpos, &curpos, 0);
 	//int collide = col_check_point((int)curpos.x, (int)curpos.y);
 	CHARACTER *ownerchar = game.get_player_char(owner);
 	CHARACTER *targetchr = game.world.intersect_character(prevpos, curpos, 6.0f, curpos, ownerchar);
-	if(targetchr || collide || lifespan < 0)
+	
+	if(type == WEAPON_BIORIFLE && collide || sticked)
+	{
+		if(!sticked)
+		{
+			sticked = true;
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)game.events.create(NETEVENTTYPE_BIOSPLASH, sizeof(NETEVENT_BIOSPLASH));
+			ev->x = curpos.x; ev->y = curpos.y;	ev->playSound = false;
+			pos = curpos;
+			game.create_sound(curpos, SOUND_BIO_IMPACT);
+		}
+		
+		direction = vec2(0, 0);
+		pos = prevpos;
+		speed = 0.0f;
+		start_tick = server_tick();
+
+		CHARACTER *ents[2];
+		int hit = game.world.find_entities(pos, 42.0f, (ENTITY**)ents, 2, NETOBJTYPE_CHARACTER);
+		if (hit)
+		{
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)game.events.create(NETEVENTTYPE_BIOSPLASH, sizeof(NETEVENT_BIOSPLASH));
+			ev->x = curpos.x; ev->y = curpos.y;	ev->playSound = true;
+			game.create_explosion(pos, owner, weapon, false);
+			game.create_sound(curpos, SOUND_BIO_EXPLODE);
+			game.world.destroy_entity(this);
+			return;
+		}
+		//formerly 28.0f
+		hit = game.world.find_entities(pos, 42.0f, (ENTITY**)ents, 2, -1);
+		if (hit > 1)
+		{
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)game.events.create(NETEVENTTYPE_BIOSPLASH, sizeof(NETEVENT_BIOSPLASH));
+			ev->x = curpos.x; ev->y = curpos.y;	ev->playSound = true;
+			game.world.destroy_entity(this);
+			return;
+		}
+		
+		if (lifespan < 0)
+		{
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)game.events.create(NETEVENTTYPE_BIOSPLASH, sizeof(NETEVENT_BIOSPLASH));
+			ev->x = curpos.x; ev->y = curpos.y;	ev->playSound = true;
+			game.world.destroy_entity(this);
+			return;
+		}
+	}
+	
+	PROJECTILE *projs[8];
+	int num = game.world.find_entities(curpos, 28.0f, (ENTITY**)projs, 8, NETOBJTYPE_PROJECTILE);
+	for(int i = 0; i < num; i++)
+	{
+		if(projs[i]->type == WEAPON_BIORIFLE && projs[i] != this)
+		{
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)game.events.create(NETEVENTTYPE_BIOSPLASH, sizeof(NETEVENT_BIOSPLASH));
+			ev->x = curpos.x; ev->y = curpos.y;	ev->playSound = false;
+			game.world.destroy_entity(projs[i]);
+			collide = 1;
+		}
+	}
+		
+	if(targetchr || (collide && type != WEAPON_BIORIFLE) || lifespan < 0)
 	{
 		if(lifespan >= 0 || weapon == WEAPON_GRENADE)
 			game.create_sound(curpos, sound_impact);
@@ -81,6 +147,13 @@ void PROJECTILE::tick()
 
 		game.world.destroy_entity(this);
 	}
+	
+	int z = col_is_teleport((int)curpos.x,curpos.y);
+  	if(config.sv_teleport && z && game.controller->is_extended())
+  	{
+ 		pos = teleport(z);
+  		start_tick = server_tick();
+	}
 }
 
 void PROJECTILE::fill_info(NETOBJ_PROJECTILE *proj)
@@ -90,7 +163,7 @@ void PROJECTILE::fill_info(NETOBJ_PROJEC
 	proj->vx = (int)(direction.x*100.0f);
 	proj->vy = (int)(direction.y*100.0f);
 	proj->start_tick = start_tick;
-	proj->type = type;
+	proj->type = type; 
 }
 
 void PROJECTILE::snap(int snapping_client)
@@ -100,6 +173,9 @@ void PROJECTILE::snap(int snapping_clien
 	if(networkclipped(snapping_client, get_pos(ct)))
 		return;
 
+	
 	NETOBJ_PROJECTILE *proj = (NETOBJ_PROJECTILE *)snap_new_item(NETOBJTYPE_PROJECTILE, id, sizeof(NETOBJ_PROJECTILE));
 	fill_info(proj);
+	
+	
 }
